#!/usr/bin/perl
=pod
-------------------------------------------------------------------------------
Nom : ANDREA F. MONACO
  
BAO1_regex.pl -- extrait et nettoie le contenu textuel des balises <title> et 
<description> d'un fichier XML-RSS en entrée et produit deux sorties: 
  
 - un fichier texte brut
 - un fichier XML

Mode d emploi: perl script.pl fil_rss.xml
-------------------------------------------------------------------------------
=cut;

use strict;

my $fichier = $ARGV[0];

open my $rss, "<:encoding(iso-8859-1)", $fichier;      
open my $txt, ">:encoding(utf-8)", "sortie.txt";  
open my $xml, ">:encoding(utf-8)", "sortie.xml";

my $tout_le_texte = "";
while (my $ligne = <$rss>){
    chomp $ligne;
    $ligne =~ s/\r//g;
    $tout_le_texte = $tout_le_texte . $ligne . " ";
    #print $tout_le_texte;
}
close $rss;

print $xml "<?xml version='1.0' encoding='UTF-8'?>\n";
print $xml "<file>\n";
my $count = 1;
while ($tout_le_texte =~ /<item>.*?<title>([^<]*)<\/title>.*?<description>([^<]*)<\/description>.*?<\/item>/g) {

    my $title = $1;
    my $description = $2;

    my ($title, $description) = &cleaning($title, $description);
    print $txt "TITRE : $title\n" ;
    print $txt "DESCRIPTION: $description\n";
    my ($title, $description) = &xml_entities($title, $description);
    print $xml "\t<item n='$count'>\n" ;
    print $xml "\t\t<titre>$title</titre>\n" ;
    print $xml "\t\t<description>$description</description>\n";
    print $xml "\t</item>\n";
    print $count;
    $count++;

}
print $xml "</file>\n";
close $txt;
close $xml;
          
sub cleaning {

  my ($title, $description) = @_;

  # cleaning <title>
  $title =~ s/ +\./\./g;
  $title =~ s/<[^>]+>//g;
  $title =~ s/&amp;/&/g;
  $title =~ s/&lt;/</g;
  $title =~ s/&gt;/>/g;
  $title =~ s/&quot;/"/g;
  $title =~ s/&apos;/'/g;

  # cleaning <description>
  $description =~ s/\n//g;
  $description =~ s/&#39;/'/g;
  $description =~ s/&#34;/"/g;
  $description =~ s/&#38;#39;/'/g;
  $description =~ s/&#38;#34;/"/g;
  $description =~ s/&amp;/&/g;
  $description =~ s/&lt;/</g;
  $description =~ s/&gt;/>/g;
  $description =~ s/&quot;/"/g;
  $description =~ s/&apos;/'/g;
  $description =~ s/<[^>]+>//g;

  return $title, $description;
} # cleaning
          
sub xml_entities {
  
  my ($title, $description) = @_;
  
  # re-encoding <title>
  $title =~ s/</&lt;/g;
  $title =~ s/>/&gt;/g;
  $title =~ s/&/&amp;/g;
  $title =~ s/"/&quot;/g;
  $title =~ s/'/&apos;/g;
  
  # re-encoding <description>
  $description =~ s/</&lt;/g;
  $description =~ s/>/&gt;/g;
  $description =~ s/&/&amp;/g;
  $description =~ s/"/&quot;/g;
  $description =~ s/'/&apos;/g;
  
  return $title, $description;
} #xml_entities
